'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbrandomtext.exe"
#Dim All

#Debug Error On
#Debug Display On

#Resource Icon logo, "images\gbrandomtext.ico"
#Resource Icon xcreate, "images\create.ico"
#Resource Icon xsort, "images\sort.ico"
#Resource Icon xopen, "images\open.ico"
#Resource Icon xcopy, "images\copy.ico"
#Resource Icon xchars, "images\chars.ico"
#Resource Icon xfilewords, "images\filewords.ico"
#Resource Icon xuserwords, "images\userwords.ico"
#Resource Icon xsettings, "images\settings.ico"
#Resource Icon xhelp, "images\help.ico"
#Resource Icon xfont, "images\font.ico"
#Resource Icon xview, "images\view.ico"
#Resource Icon xbullets, "images\bullets.ico"

$ver = "1.0"
%Unicode=1
#Include "Win32API.inc"

Enum Equates Singular
   IDT_SelectFile = 500
   IDT_View
   IDT_Create
   IDT_Sort
   IDT_Bullets
   IDT_CopyAll
   IDT_Settings
   IDT_Chars
   IDT_FileWords
   IDT_UserWords
   IDT_Font
   IDT_Help

   IDC_Toolbar

   IDC_RandomText
   IDC_UserWords
   IDC_LabelChars
   IDC_LabelFile
   IDC_LabelUser
   IDC_LabelRandomText
   IDC_FileName
   IDC_CapLetters
   IDC_LowLetters
   IDC_Numbers
   IDC_Symbols
   IDC_LabelMin
   IDC_LabelMax
   IDC_LabelCount
   IDC_Min
   IDC_Max
   IDC_Count
   IDC_UDMin
   IDC_UDMax
   IDC_UDCount
   IDC_SymbolList


   IDM_Sep
   IDM_cSep
   IDM_MinWidth
   IDM_MaxWidth
   IDM_LineCount
   IDM_Dupes
   IDM_All
   IDM_Chars
   IDM_CaseSensitive
   IDM_LinesToWords
   IDM_WordScramble
   IDM_SIRTS
   IDM_CourierNew8
   IDM_CourierNew12
   IDM_Tahoma8
   IDM_Tahoma12
   IDM_UserFont
   IDM_MinEMax
   IDM_Quick
   IDM_Punctuation
   IDM_RemoveSourcePunctuation
   IDM_ParagraphFormatting
   IDM_LowerCaseInput
   IDM_ExitWithoutSaving
   IDM_ParagraphNow
   IDM_UndoBullets
   IDM_ParagraphAll

   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete
   IDM_Clear

   TypeChars
   TypeFileWords
   TypeUserWords

   FontCN8
   FontCN12
   FontT8
   FontT12
   FontUser
End Enum

Global hDlg,hFontA,hFontB,hFontSIRTS,hContext,hToolbar,ghHook,hPopupSettings,hPopupFont,hBMP As Dword
Global RandomText() As String, SIRTSOn, OldProc, hArray() As Long
'Global qFreq, qStart, qStop As Quad

Global FontSize, FontAttr, SelectedFont, ParagraphFormatting, LowerCaseInput, ExitWithoutSaving As Long                                      'INI
Global PunctuationChars, FileFilter, UserWords, FontName, FileName, SymbolList As WStringZ * %Max_Path   'INI
Global LowLetters, CapLetters, Numbers, Symbols, MiniMode, WordScramble, Punctuation As Long        'INI
Global RemoveSourcePunctuation, MinWidth, MaxWidth, LineCount, Dupes, CaseSensitive, LinesToWords As Long       'INI
Global MinSentences, MaxSentences As Long     'INI

Function PBMain() As Long
   Local style&
'   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop _
'   Or %WS_VScroll Or %ES_AutoHScroll Or %WS_HScroll Or %ES_AutoVScroll
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %ES_WantReturn Or %WS_TabStop Or %ES_AutoHScroll Or %ES_AutoVScroll

   Randomize Timer
   Dialog New Pixels, 0, "gbRandomText   v" + $ver,300,300,400,600, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar

   Control Add Label, hDlg, %IDC_LabelChars, "Allowed Random Characters:", 10,55,150,20
   Control Add CheckBox, hDlg, %IDC_LowLetters, "a-z", 10,70,45,20
   Control Add CheckBox, hDlg, %IDC_CapLetters, "A-Z", 70,70,45,20
   Control Add CheckBox, hDlg, %IDC_Numbers, "0-9", 130,70,45,20
   Control Add CheckBox, hDlg, %IDC_Symbols, "Symbols", 190,70,60,20
   Control Add TextBox, hDlg, %IDC_SymbolList, "", 260,70,90,20

   Control Add Label, hDlg, %IDC_LabelFile, "Word File:", 10,93,50,15
   Control Add TextBox, hDlg, %IDC_FileName, "",10,110,180,20, style&, %WS_Ex_ClientEdge

   Control Add Label, hDlg, %IDC_LabelMin,"Min Width",10,145,60,15
   Control Add TextBox, hDlg, %IDC_Min,"",70,145,60,20
   Control Add "msctls_updown32", hDlg, %IDC_UDMin, "", 0, 0, 8, 8, %WS_Child Or %WS_Border _
      Or %WS_Visible Or %UDS_ArrowKeys Or %UDS_AlignRight Or %UDS_SetBuddyInt
   Control Send hDlg, %IDC_UDMin, %UDM_SetBuddy, GetDlgItem(hDlg, %IDC_Min), 0
   Control Send hDlg, %IDC_UDMin, %UDM_SetRange, 1, Mak(Long,1000,1)   'Max,Min

   Control Add Label, hDlg, %IDC_LabelMax,"Max Width",10,165,60,15
   Control Add TextBox, hDlg, %IDC_Max,"",70,165,60,20
   Control Add "msctls_updown32", hDlg, %IDC_UDMax, "", 0, 0, 8, 8, %WS_Child Or %WS_Border _
      Or %WS_Visible Or %UDS_ArrowKeys Or %UDS_AlignRight Or %UDS_SetBuddyInt
   Control Send hDlg, %IDC_UDMax, %UDM_SetBuddy, GetDlgItem(hDlg, %IDC_Max), 0
   Control Send hDlg, %IDC_UDMax, %UDM_SetRange, 1, Mak(Long,10000,1)   'Max,Min

   Control Add Label, hDlg, %IDC_LabelCount,"Line Count",10,185,60,15
   Control Add TextBox, hDlg, %IDC_Count,"",70,185,60,20
   Control Add "msctls_updown32", hDlg, %IDC_UDCount, "", 0, 0, 8, 8, %WS_Child Or %WS_Border _
      Or %WS_Visible Or %UDS_ArrowKeys Or %UDS_AlignRight Or %UDS_SetBuddyInt
   Control Send hDlg, %IDC_UDCount, %UDM_SetBuddy, GetDlgItem(hDlg, %IDC_Count), 0
   Control Send hDlg, %IDC_UDCount, %UDM_SetRange, 1, Mak(Long,10000,1)   'Max,Min

   Control Add Label, hDlg, %IDC_LabelUser, "User Words:", 140,133,120,15
   Control Add TextBox, hDlg, %IDC_UserWords, "",140,150,180,60, style&, %WS_Ex_ClientEdge

   Control Add Label, hDlg, %IDC_LabelRandomText, "Random Text:", 10,213,120,15
   Control Add TextBox, hDlg, %IDC_RandomText, "",10,230,180,160, style&, %WS_Ex_ClientEdge

   Dialog Show Modal hDlg Call DlgProc
End Function


CallBack Function DlgProc() As Long
   Local w,h As Long, temp$, UPD As NMUpDown Ptr
   Local nmtb As TBNotify Ptr, rc As Rect, P As TooltipText Ptr

   Select Case Cb.Msg
      Case %WM_InitDialog
         'QueryPerformanceFrequency qFreq
         BuildAcceleratorTable
         CreateCustomPopupMenu
         Settings_ini "get"
         SubClassTextBoxes
         If IsFalse(IsFile(FileName)) Then CreateDefaultFileName
         LoadPreviousSession   'loads UserWords and RandomText into textboxes
         If Len(UserWords)=0 Then UserWords = "This is the place to type in your own words"
         SetMenusAndToolbar
         Control Set Text hDlg, %IDC_FileName, FileName
         Control Set Text hDlg, %IDC_UserWords, UserWords
         Control Set Text hDlg, %IDC_SymbolList, SymbolList
         Control Set Text hDlg, %IDC_Min, Trim$(Str$(MinWidth))
         Control Set Text hDlg, %IDC_Max, Trim$(Str$(MaxWidth))
         Control Set Text hDlg, %IDC_Count, Trim$(Str$(LineCount))
         GetSettings
         SetControlFonts
         Font New "Courier New", 10, 1 To hFontSIRTS
         SetControlFonts
         HideWindows
         PostMessage hDlg, %WM_User+500, 0, 0

      Case %WM_User + 500

      Case %WM_Destroy
         If ExitWithoutSaving = 0 Then
            GetSettings
            SaveSession
            Settings_ini "save"
         End If
         UnSubClassTextBoxes

      Case %WM_Size
         ResizeWindow
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_Min
               If Cb.CtlMsg = %EN_Change Then
                  MinWidth = SendMessage(GetDlgItem(hDlg,%IDC_UDMin), %UDM_GetPos, 0,0)
               End If
            Case %IDC_Max
               If Cb.CtlMsg = %EN_Change Then
                  MaxWidth = SendMessage(GetDlgItem(hDlg,%IDC_UDMax), %UDM_GetPos, 0,0)
               End If
            Case %IDC_Count
               If Cb.CtlMsg = %EN_Change Then
                  LineCount = SendMessage(GetDlgItem(hDlg,%IDC_UDCount), %UDM_GetPos, 0,0)
               End If
            Case %IDM_Chars
               MsgBox WordChars, %MB_Ok + %MB_IconInformation, "Allowed Random Characters"

            Case %IDM_MinWidth
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Minimum Line Width", Str$(MinWidth),w+40,h+150)
               If Len(temp$) Then
                  MinWidth = Val(temp$)
                  SendMessage(GetDlgItem(hDlg,%IDC_UDMin), %UDM_SetPos, 0,MinWidth)
               End If


            Case %IDM_MaxWidth
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Maximum Line Width", Str$(MaxWidth),w+40,h+150)
               If Len(temp$) Then
                  MaxWidth = Val(temp$)
                  SendMessage(GetDlgItem(hDlg,%IDC_UDMax), %UDM_SetPos, 0,MaxWidth)
               End If

            Case %IDM_LineCount
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Exact Line Count", Str$(LineCount),w+40,h+150)
               If Len(temp$) Then
                  LineCount = Val(temp$)
                  SendMessage(GetDlgItem(hDlg,%IDC_UDCount), %UDM_SetPos, 0,LineCount)
               End If

            Case %IDM_All
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Min, Max, Count", Str$(MinWidth) + "," + Str$(MaxWidth) + "," + Str$(LineCount),w+40,h+150)
               If Len(temp$) Then
                  MinWidth = Val(Parse$(temp$,",",1))
                  MaxWidth = Val(Parse$(temp$,",",2))
                  LineCount = Val(Parse$(temp$,",",3))
                  SendMessage(GetDlgItem(hDlg,%IDC_UDMin), %UDM_SetPos, 0,MinWidth)
                  SendMessage(GetDlgItem(hDlg,%IDC_UDMax), %UDM_SetPos, 0,MaxWidth)
                  SendMessage(GetDlgItem(hDlg,%IDC_UDCount), %UDM_SetPos, 0,LineCount)
               End If

            Case %IDM_ParagraphAll
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Min, Max Sentences", Str$(MinSentences) + "," + Str$(MaxSentences),w+40,h+150)
               If Len(temp$) Then
                  MinSentences = Val(Parse$(temp$,",",1))
                  MaxSentences = Val(Parse$(temp$,",",2))
               End If

            Case %IDM_Quick
                MinWidth = 5 : MaxWidth = 20 : LineCount = 20
                SendMessage(GetDlgItem(hDlg,%IDC_UDMin), %UDM_SetPos, 0,MinWidth)
                SendMessage(GetDlgItem(hDlg,%IDC_UDMax), %UDM_SetPos, 0,MaxWidth)
                SendMessage(GetDlgItem(hDlg,%IDC_UDCount), %UDM_SetPos, 0,LineCount)

            Case %IDM_MinEMax
               MinWidth = MaxWidth
               SendMessage(GetDlgItem(hDlg,%IDC_UDMin), %UDM_SetPos, 0,MinWidth)

            Case %IDM_CaseSensitive
               CaseSensitive = CaseSensitive Xor 1
               SetMenusAndToolbar

            Case %IDM_LinesToWords
               LinesToWords = LinesToWords Xor 1
               SetMenusAndToolbar

            Case %IDM_WordScramble
               WordScramble = WordScramble Xor 1
               SetMenusAndToolbar

            Case %IDM_Punctuation
               Punctuation = Punctuation Xor 1
               SetMenusAndToolbar

            Case %IDM_ParagraphFormatting
               ParagraphFormatting = ParagraphFormatting Xor 1
               SetMenusAndToolbar

            Case %IDM_RemoveSourcePunctuation
               RemoveSourcePunctuation = RemoveSourcePunctuation Xor 1
               SetMenusAndToolbar

            Case %IDM_LowerCaseInput
               LowerCaseInput = LowerCaseInput Xor 1
               SetMenusAndToolbar

            Case %IDM_Dupes
               Dupes = Dupes Xor 1
               SetMenusAndToolbar

            Case %IDC_CapLetters
               CapLetters = CapLetters Xor 1
               SetMenusAndToolbar

            Case %IDC_LowLetters
               LowLetters = LowLetters Xor 1
               SetMenusAndToolbar

            Case %IDC_Numbers
               Numbers = Numbers Xor 1
               SetMenusAndToolbar

            Case %IDC_Symbols
               Symbols = Symbols Xor 1
               SetMenusAndToolbar

            Case %IDT_Settings
               MiniMode = MiniMode Xor 1
               HideWindows
               ResizeWindow

            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbrandomtext.htm"
                 w = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_SelectFile
               SelectFile
               Control Set Text hDlg, %IDC_FileName, FileName
            Case %IDT_View
               If IsFile(FileName) Then
                  w  = Shell ("Notepad " + FileName, 1)  'opens Notepad, does not wait for it to close
               Else
                  Beep
               End If
            Case %IDM_ExitWithoutSaving
               ExitWithoutSaving = 1
               Dialog End hDlg

            Case %IDT_Font
               SelectMainFont
               SetControlFonts

            Case %IDT_Chars
               GetSettings
               RandomTextGenerator %TypeChars
               If SIRTSOn Then Control Set Font hDlg, %IDC_RandomText, hFontB : SIRTSOn = 0
               Control Set Text hDlg, %IDC_RandomText, Join$(RandomText(),$CrLf)

            Case %IDT_FileWords
               GetSettings
               If IsFile(FileName) Then
                  RandomTextGenerator %TypeFileWords
                  If SIRTSOn Then Control Set Font hDlg, %IDC_RandomText, hFontB : SIRTSOn = 0
                  If ParagraphFormatting Then
                     AddParagraphFormatting
                  Else
                     Control Set Text hDlg, %IDC_RandomText, Join$(RandomText(),$CrLf)
                  End If
               Else
                  Beep
               End If

            Case %IDT_UserWords
               GetSettings
               If Len(UserWords) Then
                  RandomTextGenerator %TypeUserWords
                  If SIRTSOn Then Control Set Font hDlg, %IDC_RandomText, hFontB : SIRTSOn = 0
                  If ParagraphFormatting Then
                     AddParagraphFormatting
                  Else
                     Control Set Text hDlg, %IDC_RandomText, Join$(RandomText(),$CrLf)
                  End If
               Else
                  Beep
               End If

            Case %IDT_Sort
               SortRandomText

            Case %IDT_Bullets
               FormatAsBullets

            Case %IDT_CopyAll
               Control Get Text hDlg, %IDC_RandomText To temp$
               Clipboard Reset
               Clipboard Set Text temp$

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0
            Case %IDM_Clear
               Control Set Text hDlg, GetDlgCtrlID(GetFocus), ""

            Case %IDM_SIRTS   : CreateSIRTS

            Case %IDM_CourierNew8  : SelectedFont = %FontCN8   : SetMenusAndToolbar : SetControlFonts
            Case %IDM_CourierNew12 : SelectedFont = %FontCN12  : SetMenusAndToolbar : SetControlFonts
            Case %IDM_Tahoma8      : SelectedFont = %FontT8    : SetMenusAndToolbar : SetControlFonts
            Case %IDM_Tahoma12     : SelectedFont = %FontT12   : SetMenusAndToolbar : SetControlFonts
            Case %IDM_UserFont     : SelectedFont = %FontUser  : SetMenusAndToolbar : SetControlFonts

            Case %IDM_UndoBullets  : UndoBullets
            Case %IDM_ParagraphNow : AddParagraphFormatting

         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Menu Set Text hPopupSettings, ByCmd %IDM_MinWidth, "Minimum Line Width  (" + LTrim$(Str$(MinWidth))+ ")"
                       Menu Set Text hPopupSettings, ByCmd %IDM_MaxWidth, "Maximum Line Width  (" + LTrim$(Str$(MaxWidth))+ ")"
                       Menu Set Text hPopupSettings, ByCmd %IDM_LineCount, "Exact Line Count  (" + LTrim$(Str$(LineCount))+ ")"
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Font
                       Menu Set Text hPopupFont, ByCmd %IDM_UserFont, "User-Defined   (" + FontName + " " + LTrim$(Str$(FontSize))+ ")"
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupFont, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_SelectFile To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
           End Select
   End Select
End Function

Sub RandomTextGenerator(sType As Long)
   Local i,j,Chars,CharPos,WordPos,PosA,PosB As Long
   Local temp$, UserWordList(), pChar As String
   'QueryPerformanceCounter   qStart

   'create UserWordList()
   If sType = %TypeUserWords Then
      If LowerCaseInput Then UserWords = LCase$(UserWords)
      If LinesToWords Then
         Replace $CrLf With $Spc In UserWords
         UserWords = Shrink$(UserWords)
         If RemoveSourcePunctuation Then UserWords = Remove$(UserWords, Any PunctuationChars)
         i = ParseCount(UserWords,$Spc)
         ReDim UserWordList(i-1) As String
         Parse UserWords, UserWordList(), $Spc
      Else
         i = ParseCount(UserWords,$CrLf)
         ReDim UserWordList(i-1) As String
         Parse UserWords, UserWordList(), $Spc
      End If
      If WordScramble Then
         For i = 0 To UBound(UserWordList)
            Scramble(UserWordList(i))
         Next i
      End If
   End If

   'create FileWordList()
   If sType = %TypeFileWords Then
      If LinesToWords Then
         Open FileName For Binary As #1
         Get$ #1, Lof(1), temp$
         Close #1
         If LowerCaseInput Then temp$ = LCase$(temp$)
         If RemoveSourcePunctuation Then temp$ = Remove$(temp$, Any PunctuationChars)
         Replace $CrLf With $Spc In temp$
         temp$ = Shrink$(temp$)
         i = ParseCount(temp$,$Spc)
         ReDim FileWordList(i-1) As String
         Parse temp$, FileWordList(), $Spc
      Else
         Open FileName For Input As #1
         FileScan #1, Records To i             'get count of lines of text in the file
         Dim FileWordList(i-1) As String       'Dim 0 to count-1
         Line Input #1, FileWordList() To i    'Get entire array in one gulp, count& gives # lines read
         Close #1
         If LowerCaseInput Then
            For i = 0 To UBound(FileWordList)
               FileWordList(i) = LCase$(FileWordList(i))
            Next i
         End If
      End If
      If WordScramble Then
         For i = 0 To UBound(FileWordList)
            Scramble(FileWordList(i))
         Next i
      End If
   End If

   'create random lines from specified source Data statements, File, or random characters
   ReDim RandomText(LineCount)
   For i = 0 To UBound(RandomText)
      Chars = Rnd(MinWidth, MaxWidth)
      For j = 1 To Chars
         Select Case sType
            Case %TypeUserWords
               WordPos = Rnd(0, UBound(UserWordList))
               RandomText(i) = RandomText(i) + UserWordList(WordPos) + IIf$(j=chars,"",$Spc) 'words
            Case %TypeFileWords
               WordPos = Rnd(0, UBound(FileWordList))
               RandomText(i) = RandomText(i) + FileWordList(WordPos) + IIf$(j=chars,"",$Spc) 'words
            Case %TypeChars
               CharPos = Rnd(1, Len(WordChars))
               RandomText(i) = RandomText(i) + Mid$(WordChars,CharPos,1) 'characters
         End Select
      Next i
   Next i

   'add sentence punctation, if requested
   If Punctuation Then
      For i = 0 To UBound(RandomText)
         Mid$(RandomText(i),1,1) = UCase$(Mid$(RandomText(i),1,1))
         pChar = Choose$(Rnd(1,3),".","?","!")
         RandomText(i) = RandomText(i) + IIf$(i=UBound(RandomText),pChar,pChar+$Spc)
      Next
   End If

   'create some randomly placed duplicates
   If Dupes Then
      For i = 0 To UBound(RandomText)/5       'approximate 1/5 = 20% duplicates
         PosA = Rnd(1,UBound(RandomText))
         PosB = Rnd(1,UBound(RandomText))
         RandomText(PosA) = RandomText(PosB)
      Next i
   End If

   Control Set Focus hDlg, %IDC_RandomText

   'QueryPerformanceCounter   qStop
   '? Format$((qStop-qStart)/qFreq,"###.000") & " seconds"
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "xcreate"    '1
    ImageList Add Icon hImageList, "xsort"      '2
    ImageList Add Icon hImageList, "xopen"      '3
    ImageList Add Icon hImageList, "xcopy"      '4
    ImageList Add Icon hImageList, "xchars"     '5
    ImageList Add Icon hImageList, "xfilewords" '6
    ImageList Add Icon hImageList, "xuserwords" '7
    ImageList Add Icon hImageList, "xsettings"  '8
    ImageList Add Icon hImageList, "xhelp"      '9
    ImageList Add Icon hImageList, "xfont"      '10
    ImageList Add Icon hImageList, "xview"      '11
    ImageList Add Icon hImageList, "xbullets"   '12

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_SelectFile,  %TbStyle_Button, "Select"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_View,  %TbStyle_Button, "View"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Chars,  %TbStyle_Button, "Chars"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_FileWords,  %TbStyle_Button, "File"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_UserWords,  %TbStyle_Button, "User"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Sort,  %TbStyle_Button, "Sort"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Bullets,  %TbStyle_Button, "Bullets"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_CopyAll,  %TbStyle_Button, "Copy"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Font,  %TbStyle_Button Or %TbStyle_DropDown, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Help,  %TbStyle_Button, "Help"

    Menu New PopUp To hPopupFont
    Menu Add String, hPopupFont, "Courier New 8", %IDM_CourierNew8, %MF_Enabled
    Menu Add String, hPopupFont, "Courier New 12", %IDM_CourierNew12, %MF_Enabled
    Menu Add String, hPopupFont, "Tahoma 8", %IDM_Tahoma8, %MF_Enabled
    Menu Add String, hPopupFont, "Tahoma 12", %IDM_Tahoma12, %MF_Enabled
    Menu Add String, hPopupFont, "User-Defined", %IDM_UserFont, %MF_Enabled

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Minimum Line Width", %IDM_MinWidth, %MF_Enabled
    Menu Add String, hPopupSettings, "Maximum Line Width", %IDM_MaxWidth, %MF_Enabled
    Menu Add String, hPopupSettings, "Exact Line Count", %IDM_LineCount, %MF_Enabled
    Menu Add String, hPopupSettings, "Line Min-Max-Count", %IDM_All, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "Paragraph Min-Max Sentences", %IDM_ParagraphAll, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "Quick Min=Max", %IDM_MinEMax, %MF_Enabled
    Menu Add String, hPopupSettings, "Quick 5,20,20", %IDM_Quick, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "View Allowed Characters", %IDM_Chars, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "Case Sensitive Sort", %IDM_CaseSensitive, %MF_Enabled
    Menu Add String, hPopupSettings, "Convert Source Lines to Words", %IDM_LinesToWords, %MF_Enabled
    Menu Add String, hPopupSettings, "Create Duplicate Lines", %IDM_Dupes, %MF_Enabled
    Menu Add String, hPopupSettings, "Scramble Words", %IDM_WordScramble, %MF_Enabled
    Menu Add String, hPopupSettings, "Punctuate Sentences", %IDM_Punctuation, %MF_Enabled
    Menu Add String, hPopupSettings, "Remove Source Punctuation", %IDM_RemoveSourcePunctuation, %MF_Enabled
    Menu Add String, hPopupSettings, "Paragraph Formatting", %IDM_ParagraphFormatting, %MF_Enabled
    Menu Add String, hPopupSettings, "Lower Case Source", %IDM_LowerCaseInput, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "SIRTS", %IDM_SIRTS, %MF_Enabled
End Sub

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "465", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "wordsources\loremipsum.txt", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SymbolList", "$#%-.:_", SymbolList, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileFilter", "*.bas;*.txt;*.htm;*.inc", FileFilter, %Max_Path, INIFileName
      Getprivateprofilestring "All", "PunctuationChars", ",.?!;:", PunctuationChars, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "8", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "LowLetters", "1", temp, %Max_Path, INIFileName:  LowLetters = Val(temp)
      Getprivateprofilestring "All", "CapLetters", "1", temp, %Max_Path, INIFileName:  CapLetters = Val(temp)
      Getprivateprofilestring "All", "Numbers", "1", temp, %Max_Path, INIFileName:  Numbers = Val(temp)
      Getprivateprofilestring "All", "Symbols", "1", temp, %Max_Path, INIFileName:  Symbols = Val(temp)
      Getprivateprofilestring "All", "MinWidth", "5", temp, %Max_Path, INIFileName:  MinWidth = Val(temp)
      Getprivateprofilestring "All", "MaxWidth", "10", temp, %Max_Path, INIFileName:  MaxWidth = Val(temp)
      Getprivateprofilestring "All", "LineCount", "20", temp, %Max_Path, INIFileName:  LineCount = Val(temp)
      Getprivateprofilestring "All", "Dupes", "0", temp, %Max_Path, INIFileName:  Dupes = Val(temp)
      Getprivateprofilestring "All", "MiniMode", "1", temp, %Max_Path, INIFileName:  MiniMode = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "LinesToWords", "1", temp, %Max_Path, INIFileName:  LinesToWords = Val(temp)
      Getprivateprofilestring "All", "WordScramble", "0", temp, %Max_Path, INIFileName:  WordScramble = Val(temp)
      Getprivateprofilestring "All", "SelectedFont", Str$(%FontUser), temp, %Max_Path, INIFileName:  SelectedFont = Val(temp)
      Getprivateprofilestring "All", "Punctuation", "0", temp, %Max_Path, INIFileName:  Punctuation = Val(temp)
      Getprivateprofilestring "All", "RemoveSourcePunctuation", "1", temp, %Max_Path, INIFileName:  RemoveSourcePunctuation = Val(temp)
      Getprivateprofilestring "All", "ParagraphFormatting", "0", temp, %Max_Path, INIFileName:  ParagraphFormatting = Val(temp)
      Getprivateprofilestring "All", "LowerCaseInput", "1", temp, %Max_Path, INIFileName:  LowerCaseInput = Val(temp)
      Getprivateprofilestring "All", "MinSentences", "2", temp, %Max_Path, INIFileName:  MinSentences = Val(temp)
      Getprivateprofilestring "All", "MaxSentences", "8", temp, %Max_Path, INIFileName:  MaxSentences = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "SymbolList",SymbolList, INIFileName
      WritePrivateProfileString "All", "FileFilter",FileFilter, INIFileName
      WritePrivateProfileString "All", "PunctuationChars",PunctuationChars, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "LowLetters", (Str$(LowLetters)), INIFileName
      WritePrivateProfileString "All", "CapLetters", (Str$(CapLetters)), INIFileName
      WritePrivateProfileString "All", "Numbers", (Str$(Numbers)), INIFileName
      WritePrivateProfileString "All", "Symbols", (Str$(Symbols)), INIFileName
      WritePrivateProfileString "All", "MinWidth", (Str$(MinWidth)), INIFileName
      WritePrivateProfileString "All", "MaxWidth", (Str$(MaxWidth)), INIFileName
      WritePrivateProfileString "All", "LineCount", (Str$(LineCount)), INIFileName
      WritePrivateProfileString "All", "Dupes", (Str$(Dupes)), INIFileName
      WritePrivateProfileString "All", "MiniMode", (Str$(MiniMode)), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "LinesToWords", (Str$(LinesToWords)), INIFileName
      WritePrivateProfileString "All", "WordScramble", (Str$(WordScramble)), INIFileName
      WritePrivateProfileString "All", "SelectedFont", (Str$(SelectedFont)), INIFileName
      WritePrivateProfileString "All", "Punctuation", (Str$(Punctuation)), INIFileName
      WritePrivateProfileString "All", "RemoveSourcePunctuation", (Str$(RemoveSourcePunctuation)), INIFileName
      WritePrivateProfileString "All", "ParagraphFormatting", (Str$(ParagraphFormatting)), INIFileName
      WritePrivateProfileString "All", "LowerCaseInput", (Str$(LowerCaseInput)), INIFileName
      WritePrivateProfileString "All", "MinSentences", (Str$(MinSentences)), INIFileName
      WritePrivateProfileString "All", "MaxSentences", (Str$(MaxSentences)), INIFileName
   End If
End Sub

Sub GetSettings
   Control Get Check hDlg, %IDC_LowLetters To LowLetters
   Control Get Check hDlg, %IDC_CapLetters To CapLetters
   Control Get Check hDlg, %IDC_Numbers To Numbers
   Control Get Check hDlg, %IDC_Symbols To Symbols
   Control Get Text hDlg, %IDC_SymbolList To SymbolList
   Control Get Text hDlg, %IDC_UserWords To UserWords
   Control Get Text hDlg, %IDC_FileName To FileName
End Sub

Function WordChars() As String
   Local temp$, tmp$
   If LowLetters Then temp$ = Chr$(97 To 122)
   If CapLetters Then temp$ = temp$ + Chr$(65 To 90)
   If Numbers Then temp$ = temp$ + Chr$(48 To 57)
   If Symbols Then temp$ = temp$ + SymbolList
   Function = temp$
End Function

Sub SetMenusAndToolbar
   'Toolbar Buttons
'   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_UserWords, UserWords * %TBState_Checked Or %TBState_Enabled

   'Menus
    Menu Set State hPopupSettings, ByCmd %IDM_Dupes, Dupes * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_CaseSensitive, CaseSensitive * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_LinesToWords, LinesToWords * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_WordScramble, WordScramble * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_Punctuation, Punctuation * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_RemoveSourcePunctuation, RemoveSourcePunctuation * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_ParagraphFormatting, ParagraphFormatting * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_LowerCaseInput, LowerCaseInput * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopupFont, ByCmd %IDM_CourierNew8, 0
    Menu Set State hPopupFont, ByCmd %IDM_CourierNew12, 0
    Menu Set State hPopupFont, ByCmd %IDM_Tahoma8, 0
    Menu Set State hPopupFont, ByCmd %IDM_Tahoma12, 0
    Menu Set State hPopupFont, ByCmd %IDM_UserFont, 0
    Select Case SelectedFont
       Case %FontCN8   : Menu Set State hPopupFont, ByCmd %IDM_CourierNew8, %MFS_Checked Or %MFS_Enabled
       Case %FontCN12  : Menu Set State hPopupFont, ByCmd %IDM_CourierNew12, %MFS_Checked Or %MFS_Enabled
       Case %FontT8    : Menu Set State hPopupFont, ByCmd %IDM_Tahoma8, %MFS_Checked Or %MFS_Enabled
       Case %FontT12   : Menu Set State hPopupFont, ByCmd %IDM_Tahoma12, %MFS_Checked Or %MFS_Enabled
       Case %FontUser  : Menu Set State hPopupFont, ByCmd %IDM_UserFont, %MFS_Checked Or %MFS_Enabled
    End Select

   'CheckBox
   Control Set Check hDlg, %IDC_CapLetters, CapLetters
   Control Set Check hDlg, %IDC_LowLetters, LowLetters
   Control Set Check hDlg, %IDC_Numbers, Numbers
   Control Set Check hDlg, %IDC_Symbols, Symbols
End Sub

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      SelectedFont = %FontUser
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      SetControlFonts
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub SelectFile
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "Text Files" + $Nul + FileFilter + $Nul
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then FileName = filevar$
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_SelectFile : Function = "Select Word File"
      Case %IDT_View       : Function = "View Selected Word File"
      Case %IDT_Chars      : Function = "Create Character-Based Random Text"
      Case %IDT_FileWords  : Function = "Create Random Text From Words in File"
      Case %IDT_UserWords  : Function = "Create Random Text from User Words"
      Case %IDT_Sort       : Function = "Sort Random Text"
      Case %IDT_CopyAll    : Function = "Copy All Random Text"
      Case %IDT_Font       : Function = "Open Select Font Dialog  (" + FontName + Str$(FontSize) + ")"
      Case %IDT_Settings   : Function = "Default Settings Button Action"
      Case %IDT_Help       : Function = "Open Online Help"
      Case %IDT_Settings   : Function = ""
   End Select
End Function

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub SaveSession
   Local temp$
   Control Get Text hDlg, %IDC_UserWords To temp$
   Open Exe.Path$ + "gbrandomtext_userwords.txt" For Output As #1
   Print #1, temp$;
   Close #1

   Control Get Text hDlg, %IDC_RandomText To temp$
   Open Exe.Path$ + "gbrandomtext_randomtext.txt" For Output As #1
   Print #1, temp$;
   Close #1
End Sub

Sub LoadPreviousSession
    Local temp$, fName$
    fName$ = Exe.Path$ + "gbrandomtext_userwords.txt"
    If IsFile(fName$) Then
       Open fName$ For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_UserWords, temp$
    End If
    fName$ = Exe.Path$ + "gbrandomtext_randomtext.txt"
    If IsFile(fName$) Then
       Open fName$ For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_RandomText, temp$
    End If
End Sub

Sub CreateDefaultFileName
   Local temp$
   FileName = Exe.Path$ + "gbrandomtext_defaultwordlist.txt"
   Open FileName For Output As #1
   Print #1, "You" + $CrLf +"should" + $CrLf +"use" + $CrLf +"your" + $CrLf + "own" + $CrLf + _
              "file" + $CrLf +"name" + $CrLf +"instead" + $CrLf +"of " + $CrLf + "this" + $CrLf + "default"
   Close #1
End Sub

Sub HideWindows
   Local i As Long
   If MiniMode Then
      For i = %IDC_RandomText To %IDC_SymbolList
         Control Show State hDlg, i, %SW_Hide
      Next i
      Control Set Loc hDlg, %IDC_LabelRandomText, 10,55
      Control Set Loc hDlg, %IDC_RandomText, 10,70
      Control Show State hDlg, %IDC_LabelRandomText, %SW_Show
      Control Show State hDlg, %IDC_RandomText, %SW_Show
      Control Set Focus hDlg, %IDC_RandomText
   Else
      For i = %IDC_Toolbar To %IDC_SymbolList
         Control Show State hDlg, i, %SW_Show
      Next i
      Control Set Loc hDlg, %IDC_LabelRandomText, 10,213
      Control Set Loc hDlg, %IDC_RandomText, 10,230
   End If
End Sub

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   If MiniMode Then
      Control Set Size hDlg, %IDC_RandomText, w-20,h-80
   Else
      Control Set Size hDlg, %IDC_FileName, w-20,20
      Control Set Size hDlg, %IDC_SymbolList, w-270,20
      Control Set Size hDlg, %IDC_UserWords, w-150,60
      Control Set Size hDlg, %IDC_RandomText, w-20,h-240
   End If
End Sub

Sub SortRandomText
   Local temp$, i As Long
   Control Get Text hDlg, %IDC_RandomText To temp$
   i = ParseCount(temp$,$CrLf)
   Dim tempList(i-1) As String
   Parse temp$, tempList(), $CrLf
   If CaseSensitive Then
      Array Sort tempList$(), Collate UCase
   Else
      Array Sort tempList$()
   End If
   If SIRTSOn Then Control Set Font hDlg, %IDC_RandomText, hFontB : SIRTSOn = 0
   Control Set Text hDlg, %IDC_RandomText, Join$(tempList(),$CrLf)
End Sub

Sub SubClassTextBoxes
   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_SymbolList), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_FileName), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_UserWords), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_RandomText), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
'   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Min), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
'   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Max), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
'   OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Count), %GWL_WndProc, CodePtr(NewTBProc))  'subclass
End Sub

Sub UnSubClassTextBoxes
   SetWindowLong GetDlgItem(hDlg, %IDC_SymbolList), %GWL_WNDPROC, OldProc   'un-subclass
   SetWindowLong GetDlgItem(hDlg, %IDC_FileName), %GWL_WNDPROC, OldProc   'un-subclass
   SetWindowLong GetDlgItem(hDlg, %IDC_UserWords), %GWL_WNDPROC, OldProc   'un-subclass
   SetWindowLong GetDlgItem(hDlg, %IDC_RandomText), %GWL_WNDPROC, OldProc   'un-subclass
'   SetWindowLong GetDlgItem(hDlg, %IDC_Min), %GWL_WNDPROC, OldProc   'un-subclass
'   SetWindowLong GetDlgItem(hDlg, %IDC_Max), %GWL_WNDPROC, OldProc   'un-subclass
'   SetWindowLong GetDlgItem(hDlg, %IDC_Count), %GWL_WNDPROC, OldProc   'un-subclass
End Sub

Function NewTBProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long, hChild As Dword, pt As Point
   Select Case Msg
      Case %WM_ContextMenu
         'give focus to textbox under cursor
         GetCursorPos pt
         ScreenToClient hDlg, pt
         hChild = ChildWindowFromPoint(hDlg,pt)
         SetFocus hChild
         'remove menu items not needed
         Menu Delete hContext, 6
         Menu Delete hContext, ByCmd %IDM_UndoBullets
         If GetDlgCtrlID(GetFocus) = %IDC_RandomText Then
            Menu Add String, hContext, "-", 6,  %MF_Enabled
            Menu Add String, hContext, "Undo Bullets", %IDM_UndoBullets,  %MF_Enabled
         End If
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateCustomPopUpMenu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContext, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContext, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "Clear All", %IDM_Clear,  %MF_Enabled
'   Menu Add String, hContext, "-", %IDM_Sep,  %MF_Enabled
'   Menu Add String, hContext, "Undo Bullets", %IDM_UndoBullets,  %MF_Enabled
End Sub

Sub CreateSIRTS
   Local maxX, maxY As Long, temp$
   Dim iLevel As Long, sPattern As String, Diff As Long
   Dim i As Long, CharList As String, PatternSize As Long, x As Long, y As Long
   maxX = 60 : maxY = 40 : ReDim hArray(maxX, maxY): CreateDepthArray
   PatternSize = 10 : CharList = "gbRandomText"
   For y = 0 To maxY - 1
      iLevel = 0: sPattern = ""
      For i = 1 To PatternSize: sPattern = sPattern & Mid$(CharList, Int(Rnd * Len(CharList) + 1), 1): Next i
      Diff = PatternSize
      For x = 0 To maxX - 1
         If hArray(x, y) <> iLevel Then
            Diff = PatternSize - hArray(x, y)
            iLevel = hArray(x, y)
         End If
         sPattern = sPattern & Left$(Right$(sPattern, Diff), 1)
      Next x
      temp$ = temp$ + $CrLf + sPattern
   Next y
   Control Set Font hDlg, %IDC_RandomText, hFontSIRTS
   Control Set Text hDlg, %IDC_RandomText, Trim$(temp$,$CrLf)
End Sub

Sub CreateDepthArray
   Local maxX, maxY As Long
   maxX = 50 : maxY = 50
   Dim x As Single, y As Single
   For y = 0.2 * maxY To 0.5 * maxY
      For x = 0.2 * maxX To 0.5 * maxX
         If x < UBound(hArray, 1) And y < UBound(hArray, 2) Then hArray(x, y) = 1
      Next x: Next y
      For y = 0.3 * maxY To 0.6 * maxY
         For x = 0.3 * maxX To 0.6 * maxX
            If x < UBound(hArray, 1) And y < UBound(hArray, 2) Then hArray(x, y) = 2
         Next x: Next y
End Sub

Sub Scramble(temp$)
   Local i,j,k As Long, a$, b$
   For i = 1 To Len(temp$)
      j = Rnd(1,Len(temp$))
      k = Rnd(1,Len(temp$))
      a$ = Mid$(temp$,j,1)
      b$ = Mid$(temp$,k,1)
      Mid$(temp$,j,1) = b$
      Mid$(temp$,k,1) = a$
   Next i
End Sub

Sub SetControlFonts
   'A fonts always = size 8  'B fonts are 12 or selected by user
   Font End hFontA
   Font End hFontB

   Select Case SelectedFont
      Case %FontCN8
         Font New "Courier New", 8, 0 To hFontA
         Font New "Courier New", 8, 0 To hFontB
      Case %FontCN12
         Font New "Courier New", 8, 0 To hFontA
         Font New "Courier New", 12 , 0 To hFontB
      Case %FontT8
         Font New "Tahoma", 8, 0 To hFontA
         Font New "Tahoma", 8, 0 To hFontB
      Case %FontT12
         Font New "Tahoma", 8, 0 To hFontA
         Font New "Tahoma", 12, 0 To hFontB
      Case %FontUser
         Font New FontName, 8,0 To hFontA
         Font New FontName, FontSize, FontAttr To hFontB
   End Select

   Control Set Font hDlg, %IDC_Toolbar, hFontA

   Control Set Font hDlg, %IDC_LabelChars, hFontA
   Control Set Font hDlg, %IDC_CapLetters, hFontA
   Control Set Font hDlg, %IDC_LowLetters, hFontA
   Control Set Font hDlg, %IDC_Symbols, hFontA
   Control Set Font hDlg, %IDC_SymbolList, hFontA

   Control Set Font hDlg, %IDC_LabelFile, hFontA
   Control Set Font hDlg, %IDC_FileName, hFontA

   Control Set Font hDlg, %IDC_LabelUser, hFontA
   Control Set Font hDlg, %IDC_UserWords, hFontA

   Control Set Font hDlg, %IDC_LabelRandomText, hFontA

   Control Set Font hDlg, %IDC_LabelMin, hFontA
   Control Set Font hDlg, %IDC_LabelMax, hFontA
   Control Set Font hDlg, %IDC_LabelCount, hFontA
   Control Set Font hDlg, %IDC_Min, hFontA
   Control Set Font hDlg, %IDC_Max, hFontA
   Control Set Font hDlg, %IDC_Count, hFontA

   Control Set Font hDlg, %IDC_RandomText, hFontB
End Sub

Sub FormatAsBullets
   Local temp$, i, iCount As Long
   Control Get Text hDlg, %IDC_RandomText To temp$
   i = ParseCount(temp$,$CrLf)
   Dim tempList(i-1) As String
   Parse temp$, tempList(), $CrLf
   For i = 0 To UBound(tempList)
      Incr iCount
      tempList(i) = IIf$(iCount<10," ","") + LTrim$(Str$(iCount)) + ".  " + tempList(i)
   Next i
   Control Set Text hDlg, %IDC_RandomText, Join$(tempList(),$CrLf)
End Sub

Sub AddParagraphFormatting
   Local i,j,w,h,scroll As Long, temp$, result$
   Control Get Client hDlg, %IDC_RandomText To w,h
   Graphic Bitmap New w-10-scroll,h To hBMP
   Graphic Attach hBMP,0
   Graphic Set Font hFontB

   For i = 0 To UBound(RandomText)
      temp$ = ""
      For j = i To Min(UBound(Randomtext),i+Rnd(MinSentences,MaxSentences)-1)
         temp$ = temp$ + RandomText(j)
      Next
      result$ = result$ + $CrLf + WordWrap(temp$,w-10-scroll)
      i = j
   Next i
   Control Set Text hDlg, %IDC_RandomText, LTrim$(result$, Any $CrLf)
End Sub

Function WordWrap(temp As String, w As Long) As String
   Local rtn, Part1, Part2 As String
   Graphic Split Word temp, w To Part1, Part2
   While Len(Part2)
      rtn = rtn + $CrLf + Part1
      Graphic Split Word Trim$(Part2), w To Part1, Part2
   Wend
   Function = rtn + $CrLf + Part1
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(2)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd  = %IDT_Help           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P  : ac(c).cmd  = %IDM_ParagraphNow   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U  : ac(c).cmd  = %IDM_UndoBullets    : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub UndoBullets
   Local temp$, i, iPos As Long
   Control Get Text hDlg, %IDC_RandomText To temp$
   i = ParseCount(temp$,$CrLf)
   Dim tempList(i-1) As String
   Parse temp$, tempList(), $CrLf
   For i = 0 To UBound(tempList)
      tempList(i) = LTrim$(tempList(i))
      iPos = InStr(tempList(i),$Spc)
      If iPos Then tempList(i) = Mid$(tempList(i),iPos+2)
   Next i
   Control Set Text hDlg, %IDC_RandomText, Join$(tempList(),$CrLf)
End Sub
